#include <p18cxxx.h>
#include "i2c_master.h"

void
iniz_st7032( void )
{
  int i, j;

  for( j = 0; j < 200; j ++ ) for( i = 0; i < 3500; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x38;	// function set
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x39;	// functin set - extended instruction
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x14;	// OSC set frequency
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x7A;	// LCD contrast
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x5E;	// Power control
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x6A;	// Followet control
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( j = 0; j < 20; j ++ ) for( i = 0; i < 3500; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x0E;	// Display on
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x01;	// Display Clear
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
  for( j = 0; j < 20; j ++ ) for( i = 0; i < 3500; i ++ ) ;
}

void
command_st7032( unsigned char c )
{
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = c;
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
}

void
data_st7032( unsigned char d )
{
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x40;
  I2CDataByte[1] = d;
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
}

void
puts_st7032( char *p )
{
  int i;
  for( i = 1; i <= I2C_M_BUFLEN; i ++ ) {
    if( 0 == *p ) break;
    I2CDataByte[i] = *p++;
  }
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x40;
  I2CLengthT = i;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
}

// contrast control - 0x00 to 0x3F
void
contrast_st7032( int c )
{
  int i;

  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x39;	// functin set - extended instruction
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();

  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x5C + ( ( 0x30 & c ) >> 4 );	// Power control
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();

  for( i = 0; i < 150; i ++ ) ;
  I2CDevAddr = 0x7C;
  I2CDataByte[0] = 0x00;
  I2CDataByte[1] = 0x70 + ( 0x0f & c );	// LCD contrast
  I2CLengthT = 2;
  I2CLengthR = 0;
  I2CSTART();
  I2CREADY();
}