// EUSART routine header file

#define COMBUFLEN 64
#define COM_BUFFER_FULL 0x80
#define COM_RECV_ETX 0x01
#define TRX_TIMEOUT 10

#define STX 0x02
#define ETX 0x03
#define ACK 0x06
#define NAK 0x15

extern unsigned char com_buffer[COMBUFLEN];
extern unsigned char com_bufp, com_etx_flag;
extern int com_timeout;

void iniz_com( void );
void eusart_isr( void );
int transmit_spi_packet( unsigned int d[], int len );
void com_buffer_clear( void );
void recv_buffer_clear( void );
unsigned int crc( unsigned char *d, int len );
unsigned char hex2bin( char *p );
int transmit_ACK_packet( void );
int transmit_NAK_packet( void );
int retry_packet( void );
void packet_buffer_clear( void );
int ack_check( void );