// I2C Master handler header
#include <p18CXXX.h>
#include <i2c.h>
#define SOFTWARE_I2C

#define I2C_M_BUFLEN 20

extern unsigned char
              I2CPhase,	// phase code
              I2CDevAddr,	// I2C device address
              I2CDataByte[I2C_M_BUFLEN],	// I2C data byte, max 20 bytes
              I2CLengthT,	// data byte length for transmit
              I2CLengthR,	// data byte length for receive
              I2CCount,		// data counter(pointer)
              I2CError;		// I2C error flag
extern unsigned char I2CDiscard;	// buffer for discard

#ifndef SOFTWARE_I2C
// flags and registers
#define I2C_M_IF PIR3bits.SSP2IF // I2C master interrupt flag
#define I2C_M_ACKSTAT SSP2CON2bits.ACKSTAT // ACK status
#define I2C_M_TBF SSP2STATbits.BF // Transmit buffer full
#define I2C_M_RCEN SSP2CON2bits.RCEN // Receive enable
#define I2C_M_ACKDT SSP2CON2bits.ACKDT // ACK data
#define I2C_M_RSEN SSP2CON2bits.RSEN // restart condition
#define I2C_M_PEN SSP2CON2bits.PEN // stop conditon
#define I2C_M_ACKEN SSP2CON2bits.ACKEN // ACK enable
#define I2C_M_TX SSP2BUF	// data transmit register
#define I2C_M_RX SSP2BUF	// data receive register

// Macros
#define I2CSTART() I2CPhase=1,SSP2CON2bits.SEN=1,I2CDiscard=SSP2BUF
#define I2CREADY() while(0!=I2CPhase)

// Prototypes
void iniz_i2c( void );
#endif

#ifdef SOFTWARE_I2C
#define I2CSTART() i2cstart()
#define I2CREADY() i2cready()

// Prototypes
void iniz_i2c( void );
void i2cstart( void );
void i2cready( void );
#endif
